
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.text.DecimalFormat;

import myapp.db.exception.IntegrityConstraintException;
import myapp.db.exception.NoRowModifiedException;
import myapp.db.exception.TooManyRowsModifiedException;
import myapp.db.query.SimpleProductsSelectIterator;
import myapp.db.query.UpdProductUpriceInvoker;
import myapp.db.row.SimpleProductsSelectRow;

public class FirstBlancoDb12 {

    public static void main(String[] args) {
        // blancoDbł DBڑ͊O^܂B
        Connection conn = null;

        try {
            // vOCł̐ݒƂ͕ʂ JDBChCouCu[vɒǉKv܂B
            Class.forName("org.postgresql.Driver");
            conn = DriverManager.getConnection(
                    "jdbc:postgresql://localhost:5432/template1", "postgres",
                    "password");
            // 蓮R~bgɐݒ肵܂B
            conn.setAutoCommit(false);

            UpdProductUpriceInvoker invoker = new UpdProductUpriceInvoker(conn);
            try {
                // ProductID 15̏iXV܂B
                invoker.setInputParameter(15);
                try {
                    invoker.executeSingleUpdate();
                    conn.commit();
                    System.out.println("XV܂B");
                } catch (NoRowModifiedException e1) {
                    System.out.println("1XV܂łB:" + e1.toString());
                } catch (TooManyRowsModifiedException e1) {
                    System.out.println("2ȏXVĂ܂܂B:" + e1.toString());
                } catch (IntegrityConstraintException e1) {
                    System.out.println("f[^x[XᔽĂ܂܂B:"
                            + e1.toString());
                }
            } finally {
                // blancoDb IteratorInvoker͍ŌɃN[YsKv܂B
                invoker.close();
            }

            SimpleProductsSelectIterator iterator = new SimpleProductsSelectIterator(
                    conn);
            try {
                // ProductID 15̏i܂B
                iterator.setInputParameter(15);
                for (; iterator.next();) {
                    SimpleProductsSelectRow row = iterator.getRow();
                    DecimalFormat format = new DecimalFormat("#,###,###.##");
                    System.out.println("XV̏i\̓emFBiԍ["
                            + row.getProductid() + "] i["
                            + row.getProductname() + "] i["
                            + format.format(row.getPrice()) + "]");
                }
            } finally {
                // blancoDb IteratorInvoker͍ŌɃN[YsKv܂B
                iterator.close();
            }
        } catch (ClassNotFoundException e) {
            System.err.println("NX܂: " + e.toString());
        } catch (SQLException e) {
            System.err.println("\SQLO܂: " + e.toString());
        } finally {
            if (conn != null) {
                try {
                    conn.close();
                } catch (SQLException e1) {
                    System.err.println("RlNVN[Yɗ\SQLO܂: "
                            + e1.toString());
                }
            }
        }
    }
}
